/*******************************************************************************
 * Copyright (c) 2000, 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 * Port to the D programming language:
 *     Frank Benoit <benoit@tionex.de>
 *******************************************************************************/
module dwt.graphics.GCData;


import dwt.DWT;
import dwt.internal.win32.WINTYPES;
import dwt.internal.gdip.Gdip;
import dwt.graphics.Image;
import dwt.graphics.Device;
import dwt.graphics.Pattern;
import dwt.graphics.Font;

/**
 * Instances of this class are descriptions of GCs in terms
 * of unallocated platform-specific data fields.
 * <p>
 * <b>IMPORTANT:</b> This class is <em>not</em> part of the public
 * API for DWT. It is marked public only so that it can be shared
 * within the packages provided by DWT. It is not available on all
 * platforms, and should never be called from application code.
 * </p>
 */

public final class GCData {
    public Device device;
    public int style, state = -1;
    public int foreground = -1;
    public int background = -1;
    public Font font;
    public Pattern foregroundPattern;
    public Pattern backgroundPattern;
    public int lineStyle = DWT.LINE_SOLID;
    public float lineWidth;
    public int lineCap = DWT.CAP_FLAT;
    public int lineJoin = DWT.JOIN_MITER;
    public float lineDashesOffset;
    public float[] lineDashes;
    public float lineMiterLimit = 10;
    public int alpha = 0xFF;

    public Image image;
    public HPEN hPen, hOldPen;
    public HBRUSH hBrush, hOldBrush;
    public HBITMAP hNullBitmap;
    public HWND hwnd;
    public PAINTSTRUCT* ps;
    public int layout = -1;
    public Gdip.Graphics gdipGraphics;
    public Gdip.Pen gdipPen;
    public Gdip.Brush gdipBrush;
    public Gdip.SolidBrush gdipFgBrush;
    public Gdip.SolidBrush gdipBgBrush;
    public Gdip.Font gdipFont;
    public float gdipXOffset, gdipYOffset;
    public int uiState = 0;
    public bool focusDrawn;
}

